/*
 * edlib v1.1 Copyright 1989 Edwin Hoogerbeets
 * This code is freely redistributable as long as no charge other than
 * reasonable copying fees are levied for it.
 */
#include <stdlib.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <libraries/dos.h>
#include <errno.h>



/* GetCurrentWorkingDirectory
*/
char *
getcwd(path,len)
char *path;
int len;
{
struct FileLock *mylock;
struct FileInfoBlock *myfib;
char *backstring, *pathname[20];
int x = 0,strlength=0;

if(!(myfib = AllocMem(sizeof(struct FileInfoBlock),MEMF_PUBLIC)))
		return(NULL);

if(!(mylock = Lock("\0",ACCESS_READ)))
		{
		free(myfib);
		return(NULL);
		}

if(!(Examine(mylock,myfib)))
		{
		UnLock(mylock);
		free(myfib);
		return(NULL);
		}

do  {
	if(!(pathname[x] = malloc(strlen(myfib->fib_FileName))))
		{
		UnLock(mylock);
		free(myfib);
		return(NULL);
		}
	strcpy(pathname[x],myfib->fib_FileName);
	strlength += strlen(pathname[x]);
	x++;
	if(!(mylock = ParentDir(mylock)))
		break;
	Examine(mylock,myfib);

	}while(mylock);
x--;

if(!((int *)backstring = malloc(strlength+20)))
	{
	FreeMem(myfib,sizeof(struct FileInfoBlock));
	UnLock(mylock);
	return(NULL);
	}

sprintf(backstring,"%s:",pathname[x--]);

	while(x >= 0)
	{
	strcat(backstring,pathname[x--]);
	strcat(backstring,"/");
	};
*(backstring +strlen(backstring) -1) = 0;

if(myfib) FreeMem(myfib,sizeof(struct FileInfoBlock));
if(mylock) UnLock(mylock);

if(path && len)
	{
	while(len-- && *backstring)
		{
		*path++ = *backstring++;
		}
	if(len) *++path = 0;
	}
return(backstring);
}

