/*
 * hostname - return the Usenet name of this machine
 *
 * One interesting possibility would be to assume that the first
 * name in the sys file is our Usenet name, unless it is "ME",
 * which would require our current strategy anyway.
 *
 * 10-Jul-90 Changed for use with AmigaUUCP Plus
 *           Ingo Feulner 
 */

#include <stdio.h>
#include "libc.h"
#include "news.h"
#include "config.h"

/* 2BSD funniness */
#ifdef BSD2_10
# include <short_names.h>
#endif

extern char *FindConfig();

char *hostname()			/* return this Usenet machine's name */
{
	static char name[MAXHOST];

	if (name[0] == '\0')	/* try to get the "news hostname" */
	{
		strcpy(name, FindConfig("NodeName"));
	}

	if (name[0] == '\0')	/* else use the ordinary hostname */
		(void) gethostname(name, sizeof name);
	return name;
}
