/*
 * links.c
 *
 * Added by Ingo Feulner on 13 May 1990 to simulate links on an Amiga.
 * Hopefully OS 2.0 supports "real" links.
 *
 */

#include <stdio.h>
#include <errno.h>

#include "libc.h"
#include "news.h"
#include "config.h"
#include "active.h"
#include "mkdirs.h"
#include "headers.h"
#include "article.h"
#include "history.h"
#include "system.h"


extern char *strtok();


static char *artlinks = NULL;

boolean insertlink(artname)
register char *artname;
{
  char tmp[320];

  FILE *fh;

  if((fh = fopen(artname, "w")) != NULL)
    fclose(fh);
  else
    return(-1);


  if(artlinks != NULL)
  {
    strcpy(tmp, artlinks);
    strcat(tmp, " ");
    strcat(tmp, artname);
    free(artlinks);
  }
  else
  {
    strcpy(tmp, artname);
  }

  artlinks = strsave(tmp);

  return 0;
}

statust writelinks(art)
register struct article *art;
{
  char tmp[320];
  register char *token;


  if(artlinks == NULL)
    return(0);

  strcpy(tmp, artlinks);

  token = strtok(tmp, " ");
  while(token != NULL)
  {
    if((link(art->a_tmpf, token)) != 0)
      warning("Linking '%s' to '%s' failed.", art->a_tmpf, token);

    token = strtok((char *)NULL, " ");
  }

  free(artlinks);
  artlinks = NULL;
  return(0);
}

